
#include "ViewController.h"
#include "mdaOverdriveController.h"
#include "mdaOverdriveProcessor.h"

namespace Steinberg {
	namespace Vst {
		namespace mda {

			IdStringPtr ViewController::kMessageNoChange = "kMessageNoChange";
			
			//------------------------------------------------------------------------
			IControlListener* ViewController::getControlListener(const char* controlTagName)
			{
				return DelegationController::getControlListener(controlTagName);
			}
			//------------------------------------------------------------------------
			CView* ViewController::verifyView(CView* view, const UIAttributes& attributes, const IUIDescription* description)
			{
				CControl* control = dynamic_cast<CControl*> (view);
				if (control)
				{
					if (control->getTag() >= 0)
					{
						control->addDependency(this);
						controls.push_back(control);
						valueChanged(control);
					}
				}
				return DelegationController::verifyView(view, attributes, description);
			}


			//------------------------------------------------------------------------
			CMessageResult ViewController::notify(CBaseObject* object, IdStringPtr message)
			{
				if (message == CControl::kMessageValueChanged)
				{
					valueChanged(dynamic_cast<CControl*> (object));
					return kMessageNotified;
				}
				return kMessageUnknown;
			}
			void ViewController::valueChanged(CControl* pControl)
			{
				if (pControl == 0)
					return;

				float ctrlValue = pControl->getValue();

				switch (pControl->getTag())
				{

				case Steinberg::Vst::mda::OverdriveController::kParamDriveMode:

				{
					CControl* ct =getControlByTag(Steinberg::Vst::mda::OverdriveController::kParamDriveModeCoeff);
					if (ct != 0) {
						ct->setVisible((ctrlValue == 1.0f));
						// JO 10.2.17: setVisible works, setMouseEnabled NOT!
						//ct->setVisible(false);
						//ct->setMouseEnabled((ctrlValue == 1.0f));
						//ct->setValue(ctrlValue);
						////ct->setVisible(true);
						////ct->setDisabledBackground(bDisabledKnob); 
						////ct->setDirty(true);
						//ct->invalid();
						//ct->valueChanged();						 
					}
					break;
				}

				//case Steinberg::Vst::mda::OverdriveController::kParamDriveModeCoeff:

				//{
				//	CControl* ct = getControlByTag(Steinberg::Vst::mda::OverdriveController::kParamDriveMode);
				//	if (ct != 0) {
				//		pControl->setMouseEnabled((ct->getValue() == 1.0f));
				//	}
				//	break;
				//}
				}

			}
			CControl* ViewController::getControlByTag(int32 tag) {
				for (std::list<CControl*>::const_iterator it = controls.begin(); it != controls.end(); it++)
					if ((*it)->getTag() == tag)
						return *it;
				return NULL;
			}
		}
	}
}

