#pragma once

#include "vstgui/plugin-bindings/vst3editor.h"
#include "vstgui/uidescription/delegationcontroller.h"

namespace Steinberg {
	namespace Vst {
		namespace mda {
			//------------------------------------------------------------------------
			class ViewController : public DelegationController, public CBaseObject
			{
			public:
				ViewController(IController* controller) : DelegationController(controller) { bDisabledKnob = new CBitmap("od41xd.png"); }
				~ViewController() {
					for (std::list<CControl*>::const_iterator it = controls.begin(); it != controls.end(); it++)
						(*it)->removeDependency(this);
				};

				CView* verifyView(CView* view, const UIAttributes& attributes, const IUIDescription* description) VSTGUI_OVERRIDE_VMETHOD;
				IControlListener* getControlListener(const char* controlTagName) VSTGUI_OVERRIDE_VMETHOD;
				void valueChanged(CControl* pControl) VSTGUI_OVERRIDE_VMETHOD;

				CMessageResult notify(CBaseObject* object, IdStringPtr message) VSTGUI_OVERRIDE_VMETHOD;

			protected:
				CBitmap * bDisabledKnob;
				static IdStringPtr kMessageNoChange;
				CControl* getControlByTag(int32 tag);
				std::list<CControl*> controls;
			};
		}
	}
}