/*
 *  mdafactory.cpp
 *  mda-vst3
 *
 *  Created by Arne Scheffler on 6/13/08.
 *
 *  mda VST Plug-ins
 *
 *  Copyright (c) 2008 Paul Kellett
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#include "public.sdk/source/main/pluginfactoryvst3.h"
#include "Overdrive_ui.h"
#include "mdaOverdriveController.h"

#include "public.sdk\jo\source\helpers.h"
#include "version.h"

//-----------------------------------------------------------------------------
bool InitModule () { return true; }
bool DeinitModule () { return true; }

//-----------------------------------------------------------------------------
#define kVersionString	FULL_VERSION_STR

using namespace Steinberg::Vst;

BEGIN_FACTORY_DEF (stringCompanyName, 
	"http://www.retnz.de",
	"mailto:info@retnz.de")

//-----------------------------------------------------------------------------
DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::mda::ProcessorWithUIController::cid),
	PClassInfo::kManyInstances,
	kVstAudioEffectClass,
	stringPluginName,
	Vst::kDistributable,
	Vst::PlugType::kFxDistortion,
	FULL_VERSION_STR,
	kVstVersionString,
	Steinberg::Vst::mda::ProcessorWithUIController::createInstance)

	DEF_CLASS2 (INLINE_UID_FROM_FUID(Steinberg::Vst::mda::ControllerWithUI::cid),
		PClassInfo::kManyInstances,
		kVstComponentControllerClass,
		stringPluginName,
		0,						// not used here
		"",						// not used here
		FULL_VERSION_STR,
		kVstVersionString,
		Steinberg::Vst::mda::ControllerWithUI::createInstance)
//-----------------------------------------------------------------------------

END_FACTORY

